// demo1.cpp : Defines the entry point for the console application.
//


#include "stdafx.h"
#import ".\gsqlparser_ao.dll"  no_namespace
#include ".\debug\gsqlparser_ao.tlh"

void pp();
void tolang();
void replacetoken();
void createparser();
void printFields();
void getdbobjects();

/// Caller Must SysFreeString on the BSTR out parm
HRESULT StringToBSTR(char *lpzString, DWORD cbSize, BSTR &bstrString);

/// Caller must Call:
/// HeapFree(GetProcessHeap(),0,lpzString); 
/// to release allocated buffer
HRESULT BSTRToString(BSTR bstrString,char **lpzString,DWORD &buflen);

HRESULT HResultFromLastError(DWORD dwError = 0);


int _tmain(int argc, _TCHAR* argv[])
{
		if FAILED(CoInitialize(NULL))
	{
		CoUninitialize();
   	    printf("failed!\n");
		return -1;
	}
  pp();
// getdbobjects();

//  tolang();
//	replacetoken();
//	printFields();
	CoUninitialize();
	return 0;
}



void createparser()
{
	IGSqlParserPtr sqlparser;
	long a;
    BSTR lcbstr; 
	char  buffer[200];
	char *lpzStr = NULL;
	DWORD cbSize = 0;

   	
	for (int k = 0; k< 3000; k++){
      sqlparser.CreateInstance("gsqlparser_ao.GSqlParser");
      sqlparser->CreateInstance(DbVOracle);
	
	}
}

void pp()
{
//	using namespace gsqlparser_ao;
	IGSqlParserPtr sqlparser;
	long a;
    BSTR lcbstr; 
	char  buffer[200];
	char *lpzStr = NULL;
	DWORD cbSize = 0;

    sqlparser.CreateInstance("gsqlparser_ao.GSqlParser");
	sqlparser->CreateInstance(DbVOracle);
   	
	for (int k = 0; k< 300; k++){
    sprintf( buffer, "%s%d", "select a,b from c where a>",k );
	sqlparser->SqlText = buffer;
	
	sqlparser->PrettyPrint();
//	sqlparser->Parse(); 
//	sqlparser->GetRawSqlStatements();
    BSTRToString( (wchar_t *)sqlparser->FormattedSqlText,&lpzStr,cbSize);
 //   BSTRToString( (wchar_t *)sqlparser->VersionId,&lpzStr,cbSize);
    printf(lpzStr);
    printf("\n");
        /// Must release allocated string 
    HeapFree(GetProcessHeap(),0,lpzStr);
	}
    char str[10];
	scanf("%c", str);
 
}

void getdbobjects()
{
	IGSqlParserPtr sqlparser; 
	char buffer[200]; 
	char *lpzStr = NULL; 
	DWORD cbSize = 0; 

	sqlparser.CreateInstance("gsqlparser_ao.GSqlParser"); 
	sqlparser->CreateInstance(DbVOracle); 
	sprintf( buffer, "%s", "select f1,f2,func(f1) from t1 where f3> any (select t1.f4,t2.f5 from t2 where f6>0)"); 
	sqlparser->SqlText = buffer; 
	long a = sqlparser->Parse(); 

	if (a != 0 ) 
	{ 
		BSTRToString( (wchar_t *)sqlparser->ErrorMessages, &lpzStr, cbSize); 
		printf(lpzStr); 
		/// Must release allocated string 
		HeapFree(GetProcessHeap(),0,lpzStr); 
	} 

	char str[21];

	ILzDBObjectListPtr tablelist = sqlparser->TableList;
	printf("tables:\n");
	for (int m=0; m< tablelist->Count();m++){
		ILzDBObjectPtr dbobject = tablelist->Items[m];
        BSTRToString( (wchar_t *)dbobject->ObjectName,&lpzStr,cbSize);
		printf(lpzStr);
		printf("\n");
	}

	ILzDBObjectListPtr fieldlist = sqlparser->FieldList;
	printf("fields:\n");
	for (int m=0; m< fieldlist->Count();m++){
		ILzDBObjectPtr dbobject = fieldlist->Items[m];
        BSTRToString( (wchar_t *)dbobject->ObjectName,&lpzStr,cbSize);
		//printf("\n");
		printf(lpzStr);
		printf("\t table:");
		ILzTableListPtr tlist = dbobject->LinkedObjects;
		for (int n=0; n<tlist->Count();n++){
			ILzTablePtr dbtable = tlist->Tables[n];
		    BSTRToString( (wchar_t *)dbtable->TableFullname,&lpzStr,cbSize);
			printf(lpzStr);
			printf(",");
		}
		printf("\n");
	}

	ILzDBObjectListPtr functionlist = sqlparser->FunctionList;
	if (functionlist->Count() > 0){
		printf("functions:\n");
		for (int m=0; m< functionlist->Count();m++){
			ILzDBObjectPtr dbobject = functionlist->Items[m];
			BSTRToString( (wchar_t *)dbobject->ObjectName,&lpzStr,cbSize);
			printf(lpzStr);
			printf("\n");
		}
	}

	ILzDBObjectListPtr procedurelist = sqlparser->ProcedureList;
	if (procedurelist->Count() > 0){
		printf("proceudre:\n");
		for (int m=0; m< procedurelist->Count();m++){
			ILzDBObjectPtr dbobject = procedurelist->Items[m];
			BSTRToString( (wchar_t *)dbobject->ObjectName,&lpzStr,cbSize);
			printf(lpzStr);
			printf("\n");
		}
	}

	ILzDBObjectListPtr triggerlist = sqlparser->TriggerList;
	if (triggerlist->Count() > 0){
		printf("trigger:\n");
		for (int m=0; m< triggerlist->Count();m++){
			ILzDBObjectPtr dbobject = triggerlist->Items[m];
			BSTRToString( (wchar_t *)dbobject->ObjectName,&lpzStr,cbSize);
			printf(lpzStr);
			printf("\n");
		}
	}

	scanf("%c", str);

}


void tolang()
{
//	using namespace gsqlparser_ao;
	IGSqlParserPtr sqlparser;
	long a;
    BSTR lcbstr; 
	char  buffer[200];
	char *lpzStr = NULL;
	DWORD cbSize = 0;

    sqlparser.CreateInstance("gsqlparser_ao.GSqlParser");
	sqlparser->CreateInstance(DbVOracle);
   	
	for (int k = 0; k< 300; k++){
    sprintf( buffer, "%s%d", "select a,b from c where a>",k );
	sqlparser->SqlText = buffer;
	
	a = sqlparser->Parse();
	if (a ==0 ){
		lcbstr = sqlparser->ToVc("var1");
        BSTRToString( lcbstr,&lpzStr,cbSize);
        printf(lpzStr);
        printf("\n");
        /// Must release allocated string 
        HeapFree(GetProcessHeap(),0,lpzStr);
	}

	}
 
}


void replacetoken()
{
//	using namespace gsqlparser_ao;
	IGSqlParserPtr sqlparser;
	ISourceTokenListPtr stl;
	ISourceTokenPtr st;

	long a;
    BSTR lcbstr; 
	char  buffer[200];
	char *lpzStr = NULL;
	DWORD cbSize = 0;
	enum ITokenStatus s;

    sqlparser.CreateInstance("gsqlparser_ao.GSqlParser");
	sqlparser->CreateInstance(DbVOracle);

	for (int k = 0; k< 1000; k++){
		sprintf( buffer, "%s%d", "select a,b from :c where a>",k );
		sqlparser->SqlText = buffer;
		a = sqlparser->Parse();
		if (a != 0 )
		{
		   BSTRToString( (wchar_t *)sqlparser->ErrorMessages,&lpzStr,cbSize);
		   printf(lpzStr);
			/// Must release allocated string 
		   HeapFree(GetProcessHeap(),0,lpzStr);
		}else{
		
			stl = sqlparser->SourceTokenList;
			for (int l = 0; l<stl->GetCount(); l++)
		   {
				st = stl->SourceTokens[l]; 
		   if (st->TokenType == ttNumber)
				{
					sprintf(buffer,"%s%d",":",k);
					st->SourceCode = buffer;
				}

		   if (st->TokenType == ttBindVar)
				{
					sprintf(buffer,"%s%d","bindvar",k);
					st->SourceCode = buffer;
				}
		   }
			BSTRToString( (wchar_t *)sqlparser->GetTextFromParseTree(),&lpzStr,cbSize);
		   printf(lpzStr);
			/// Must release allocated string 
		   HeapFree(GetProcessHeap(),0,lpzStr);
		}
	} //for 
}



void printFields() 
{ 
	IGSqlParserPtr sqlparser; 
	char buffer[200]; 
	char *lpzStr = NULL; 
	DWORD cbSize = 0; 

	sqlparser.CreateInstance("gsqlparser_ao.GSqlParser"); 
	sqlparser->CreateInstance(DbVOracle); 
	sprintf( buffer, "%s", "select a,b from c where a>1"); 
	sqlparser->SqlText = buffer; 
	long a = sqlparser->Parse(); 

	if (a != 0 ) 
	{ 
		BSTRToString( (wchar_t *)sqlparser->ErrorMessages, &lpzStr, cbSize); 
		printf(lpzStr); 
		/// Must release allocated string 
		HeapFree(GetProcessHeap(),0,lpzStr); 
	} 

	ILzStatementListPtr sqlStatements = sqlparser->GetSqlStatements(); 
	for (int l = 0; l <sqlStatements->Count(); ++l) 
	{ 
		ICustomSqlStatementPtr sqlstmt = sqlStatements->Statements[l]; 
		ISourceTokenListPtr stl = sqlstmt->SourceTokenList; 
		for (int k = 0; k <stl->GetCount(); k++) 
		{ 
			ISourceTokenPtr st = stl->SourceTokens[k]; 
			if ((st->GetDBObjType() == IDBObjectType::ttObjField) || (st->GetDBObjType() == IDBObjectType::ttObjFieldAlias)) 
			{ 
					printf("field\n");
					printf("\n");
               BSTRToString( (wchar_t *)st->GetAsText(),&lpzStr,cbSize);
				printf(lpzStr);
				//std::cout << "Field or Field alias: " <<st->GetAsText(); 
			} 
			if ((st->GetDBObjType() == IDBObjectType::ttObjTable) || (st->GetDBObjType() == IDBObjectType::ttObjTableAlias)) 
			{ 
				//std::cout << "Table or Table alias: " <<st->GetAsText(); 
					printf("table\n");
					printf("\n");
               BSTRToString( (wchar_t *)st->GetAsText(),&lpzStr,cbSize);
				printf(lpzStr);
			} 
		} 
	} 
} 




/// Caller must Call:
/// HeapFree(GetProcessHeap(),0,lpzString); 
/// to release allocated buffer
HRESULT BSTRToString(BSTR bstrString,char **lpzPassedString,DWORD &buflen) {

//buflen = SysStringLen((unsigned short *)vResult.pbstrVal);

char *lpzString = NULL;

__try {
	buflen = SysStringLen(bstrString);
	if (buflen == 0)  {
	   *lpzPassedString = NULL;
	   return 0;
	}

	lpzString = (char *) HeapAlloc (GetProcessHeap (), 0, buflen + 1); 
	if (!lpzString) 
	   return HResultFromLastError();


	/// ***  4th parm (Buflen) parameter must not be the default (-1) or NULLs will terminate the string
	if (0 == WideCharToMultiByte(CP_ACP, 0, bstrString, buflen, 
								 lpzString, buflen + 1, NULL, NULL)) {
	   buflen = 0;
	   *lpzPassedString = NULL;
	   return HResultFromLastError();
	}

	// null terminate string
	*(lpzString + buflen) = 0;  // This is not really necessary but

	*lpzPassedString = lpzString;
}
__except(EXCEPTION_EXECUTE_HANDLER) {
    __try { 
		if (lpzString)
			 HeapFree(GetProcessHeap(),0,lpzString);
	}
     __except(EXCEPTION_EXECUTE_HANDLER) {;}

	 *lpzPassedString = NULL;
	 buflen = 0;
     return -1;
}

return 0;
}

/// Caller must call SysFreeString() on bstr
HRESULT StringToBSTR(char *lpzString, DWORD cbSize, BSTR &bstrString) {

    OLECHAR *wzString = NULL;

__try {
    bstrString = NULL;

    if (cbSize == 0)  {
		if (!lpzString) {
			bstrString = NULL;
			return 0;
		}
		cbSize = strlen(lpzString);
	}

	wzString = (OLECHAR *) HeapAlloc (GetProcessHeap (), 0, cbSize * 2 + 2  );
	if (wzString == NULL) 
		return HResultFromLastError();

	if (0 == MultiByteToWideChar(CP_ACP, 0, (const char*)lpzString, cbSize, wzString, cbSize ) ) 
		return HResultFromLastError();

	bstrString = SysAllocStringLen(wzString,cbSize);
	if (NULL == bstrString) 
		return HResultFromLastError();

    /// Release the Wide character string
	__try {
		HeapFree(GetProcessHeap(),0,wzString);
	}
    __except(EXCEPTION_EXECUTE_HANDLER) {
        return -1;
	}
}
__except(EXCEPTION_EXECUTE_HANDLER) {
	__try {
		if (wzString)
			HeapFree(GetProcessHeap(),0,wzString);
		if (bstrString)
			SysFreeString(bstrString);
	}
    __except(EXCEPTION_EXECUTE_HANDLER) {;}

	bstrString = NULL;    
	return -1;
}

	return 0;
}


HRESULT HResultFromLastError(DWORD dwError)
{
    if (dwError == 0) 
	   dwError = GetLastError();

	return HRESULT_FROM_WIN32(dwError);
}


